=== debian/changelog ===
coreboot (24.08+dfsg-2) unstable; urgency=medium

  * d/rules: remove nonexistent util/ targets
  * d/rules: set exit on error for util targets
  * Rename branches to DEP-14 and add gbp.conf
  * Add debug symbols to utils to avoid warnings
  * d/manpages: fix formatting, SPDX header and update details
  * d/salsa-ci: disable blhc check as Makefiles ignore flags

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Thu, 12 Dec 2024 14:54:08 +0000

coreboot (24.08+dfsg-1) unstable; urgency=medium

  * d/copyright: Update Files-excluded for import
  * d/watch: change version mangling as ~ breaks build
  * New upstream version 24.08+dfsg
    + Note, new numbering after 4.22 is Year.Month.Sub
  * d/copyright: redo all entries after major release
  * d/clean: remove nonexistent files in new release
  * d/patches: refresh patch: vboot-Disable-Werror
  * d/patches: add util/intelmetool patch to include path
  * d/rules, d/patch: add patch to replace Doc version
  * Add util/cbmem bin to install file
  * d/rules: override clean target to avoid tracked file
  * Add manpages and replace auto generated ones
  * d/rules: add CFLAG to produce more debug symbols
  * d/control: add new docs dependency myst-parser
  * d/control: downgrade util Recommends to Suggests
  * d/control: update binary package descriptions
  * d/control: update Standards-Version to 4.6.2
  * d/control: update Maintainer from QA (Closes: #1055811)
  * d/salsa-ci: add explicit upstream branch exclusion

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Tue, 10 Dec 2024 19:06:59 +0000
