=== debian/control ===
Source: coreboot
Section: utils
Priority: optional
Maintainer: Ahmad Khalifa <ahmad@khalifa.ws>
Build-Depends: debhelper-compat (= 13),
 libpci-dev,
 pciutils,
 python3-recommonmark <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 python3-sphinxcontrib.ditaa <!nodoc>,
 python3-myst-parser <!nodoc>,
 sphinx-common,
 zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/coreboot
Vcs-Git: https://salsa.debian.org/debian/coreboot.git
Homepage: https://www.coreboot.org/

Package: coreboot-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: flashrom, ree, coreboot-utils-doc
Replaces: cbfstool, inteltool, msrtool, nvramtool, superiotool
Conflicts: cbfstool, inteltool, msrtool, nvramtool, superiotool
Description: Coreboot firmware utilities
 Free Software project aimed at replacing the proprietary BIOS
 (firmware) found in most computers.
 .
 This package contains various utilities used to develop and configure
 systems with coreboot:
   bucts, cbfs-compression-tool, cbfstool, cbmem, ectool, elogtool, fmaptool,
   ifdtool, ifittool, ifwitool, intelmetool, inteltool, intelvbttool, msrtool,
   nvramtool, pmh7tool, rmodtool, superiotool

Package: coreboot-utils-doc
Architecture: all
Build-Profiles: <!nodoc>
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
 libjs-jquery,
 libjs-underscore
Recommends: coreboot-utils
Replaces: cbfstool, inteltool, msrtool, nvramtool, superiotool
Conflicts: cbfstool, inteltool, msrtool, nvramtool, superiotool
Description: Coreboot firmware utilities - documentation
 Free Software project aimed at replacing the proprietary BIOS
 (firmware) found in most computers.
 .
 This package contains documentation for the coreboot system.
