=== debian/changelog ===
coreboot (24.12+dfsg-2ubuntu1) plucky; urgency=medium

  * Don't use -O3 on Ubuntu's amd64 & ppc64el (LP: #2099764)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 03 Apr 2025 21:41:36 -0400

coreboot (24.12+dfsg-2) unstable; urgency=medium

  * d/rules: Quiter build logs, remove DH_VERBOSE
  * d/control: Limit Architecture to linux-any targets

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Mon, 24 Feb 2025 18:02:27 +0000

coreboot (24.12+dfsg-1) unstable; urgency=medium

  * Update upstream signing keys
  * New upstream version 24.12+dfsg
  * d/control: set docs package as Multi-Arch: foreign
  * Override lintian P/X for manpages and long line
  * util/msrtool: replace static d/Makefile with substitution
  * d/*: minor formatting fixes with wrap-and-sort
  * d/control: update standards version to 4.7.0
  * d/patches: add description and hardening-fortify flag
  * d/copyright: update Excludes and Files to match new version
  * d/control: remove sphinx-ditaa build depends

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Sun, 16 Feb 2025 20:07:10 +0100
